#ifndef CONFIGUREREADERWRITER_H
#define CONFIGUREREADERWRITER_H

#include "gmc-common_global.h"

#include <QRegExp>

class QByteArray;
class QString;

class GMC_COMMON_SHARED_EXPORT RegExpHandler
{

public:

    static bool readSystemConfigureFile( const QString & /*fileName*/
                                       , RegExpHandler & /*regExpHandler*/
                                       , QString & /*errorString*/ );
    static bool rewriteSystemConfigureFile( const QString & /*fileName*/
                                          , RegExpHandler & /*regExpHandler*/
                                          , QString & /*errorString*/
                                          , bool /*backup*/ = true );

    RegExpHandler( const QString & /*regExpString*/ );
    virtual ~RegExpHandler();

    QRegExp &regExp();

protected:

    static bool safeCopy( const QString & /*sourceName*/
                        , const QString & /*desinationName*/
                        , QString & /*errorString*/ );

    virtual bool handleRegExp( QByteArray * /*byteArray*/ = 0 ) = 0;
    virtual bool finalHandleRegExp( QByteArray * /*byteArray*/ );

protected:

    QRegExp _regExp;

};

#endif // CONFIGUREREADERWRITER_H
