#ifndef ELEMENTMODEL_H
#define ELEMENTMODEL_H

#include "gmc-common_global.h"

#include "treenodemodel.h"
#include "elementmodelextension.h"

class Element;

class GMC_COMMON_SHARED_EXPORT ElementModel
: public TreeNodeModel
, public ElementModelExtension
{

    Q_OBJECT

public:

    ElementModel( QObject * /*parent*/ = 0 );
    ElementModel( TreeNode * /*rootNode*/, QObject * /*parent*/ = 0 );
    virtual ~ElementModel();

};

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT ElementSortFilterProxyModel
: public TreeNodeSortFilterProxyModel
, public ElementModelExtension
{

    Q_OBJECT

public:

    ElementSortFilterProxyModel( int /*specialFilters*/ = TreeNodeSortFilterProxyModel::UndefinedFilterType
                               , QObject * /*parent*/ = 0 );
    ElementSortFilterProxyModel( QSet< int > /*acceptColumns*/
                               , int /*specialFilters*/ = TreeNodeSortFilterProxyModel::UndefinedFilterType
                               , QObject * /*parent*/ = 0 );

    virtual ~ElementSortFilterProxyModel();

//protected:
//    virtual bool lessThan( const QModelIndex & /*left*/, const QModelIndex & /*right*/ ) const;
//    virtual bool filterAcceptsRow( int /*srcRow*/, const QModelIndex & /*srcParentIndex*/ ) const;

};

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT GroupInvisibleElementSortFilterProxyModel
: public ElementSortFilterProxyModel

{

    Q_OBJECT

public:

    GroupInvisibleElementSortFilterProxyModel( QObject * /*parent*/ = 0 );
    GroupInvisibleElementSortFilterProxyModel( QSet< int > /*acceptsColumn*/, QObject *parent = 0 );

    virtual ~GroupInvisibleElementSortFilterProxyModel();

    const QString &groupElementType() const;
    void setGroupElementType( const QString & /*groupElementType*/
                            , bool /*force*/ = false );

protected:

    virtual bool filterAcceptsRow( int /*srcRow*/, const QModelIndex & /*srcParentIndex*/ ) const;

protected:

    QString _groupElementType;

};

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT SelectableElementSortFilterProxyModel
: public ElementSortFilterProxyModel
{

    Q_OBJECT

public:

    SelectableElementSortFilterProxyModel( QObject * /*parent*/ = 0 );
    SelectableElementSortFilterProxyModel( QSet< int > /*acceptsColumn*/, QObject *parent = 0 );

    virtual ~SelectableElementSortFilterProxyModel();

    virtual QVariant data( const QModelIndex &index, int role ) const;

    int selectionDisplayRole() const;
    void setSelectionDisplayRole( int /*selectionDisplayRole*/ );

protected:

    int _selectionDisplayRole;

};

//******************************************************************************

#endif // ELEMENTMODEL_H
