#ifndef ELEMENTSWIDGETPROXYMODEL_H
#define ELEMENTSWIDGETPROXYMODEL_H

#include "gmc-common_global.h"

#include "treenodemodel.h"
#include "elementmodelextension.h"

class TreeNode;

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT ListWidgetProxyModel
: public FilterTreeNodeSortFilterProxyModel
, public ElementModelExtension
{

    Q_OBJECT

public:

    ListWidgetProxyModel( int /*specialFilters*/ = TreeNodeSortFilterProxyModel::UndefinedFilterType
                        , QObject * /*parent*/  = 0 );
    virtual ~ListWidgetProxyModel();

};


//******************************************************************************

class GMC_COMMON_SHARED_EXPORT NodesWidgetProxyModel
: public ListWidgetProxyModel
{

    Q_OBJECT

public:

    NodesWidgetProxyModel( int /*specialFilters*/ = TreeNodeSortFilterProxyModel::UndefinedFilterType
                         , QObject * /*parent*/  = 0 );
    virtual ~NodesWidgetProxyModel();

protected:

    virtual bool filterAcceptsRow( int /*srcRow*/, const QModelIndex & /*srcParentIndex*/ ) const;

};

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT ElementsWidgetProxyModel
: public ListWidgetProxyModel
{

    Q_OBJECT

public:

    ElementsWidgetProxyModel( int /*specialFilters*/ = TreeNodeSortFilterProxyModel::UndefinedFilterType
                            , QObject * /*parent*/  = 0 );
    virtual ~ElementsWidgetProxyModel();

protected:

    virtual bool filterAcceptsColumn( int /*srcColumn*/, const QModelIndex & /*srcParentIndex*/ ) const;
    virtual bool filterAcceptsRow( int /*srcRow*/, const QModelIndex & /*srcParentIndex*/ ) const;

};

//******************************************************************************

#endif // ELEMENTSWIDGETPROXYMODEL_H
