#ifndef EVENTS_H
#define EVENTS_H

#include "gmc-common_global.h"

#include <QEvent>
#include <QString>

class AbstractTask;

namespace McEvents
{
    enum MyEvents { Start = 1001
                  , TaskPerformed = 1002 };
}

class GMC_COMMON_SHARED_EXPORT StartEvent : public QEvent
{

public:

    explicit StartEvent( const QString & /*pluginPath*/ );
    virtual ~StartEvent();

    const QString &pluginPath() const;

protected:

    QString _pluginPath;

};

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT TaskPerformedEvent : public QEvent
{

public:

    explicit TaskPerformedEvent( AbstractTask * /*task*/ );
    virtual ~TaskPerformedEvent();

    AbstractTask *task() const;

protected:

    AbstractTask *_task;

};

#endif
