#ifndef NODECONTAINER_H
#define NODECONTAINER_H

#include "gmc-common_global.h"

#include <QObject>

class QAbstractItemModel;

class TreeNode;
class TreeNodeModel;

class GMC_COMMON_SHARED_EXPORT NodeContainer : public QObject
{
    Q_OBJECT

signals:

    void nodeContainerAboutToBeReset();
    void nodeContainerReset( const TreeNode * );
    void setCurrentNode( TreeNode * );
    void expandCurrentNode( TreeNode * );

public:

    NodeContainer(QObject *parent = 0);
    virtual ~NodeContainer();

    TreeNode *rootNode() const;

    TreeNodeModel *treeNodeModel() const;

protected:

    TreeNode *_rootNode;
    TreeNodeModel *_treeNodeModel;

};

#endif // NODECONTAINER_H
