#ifndef PLUGIN_H
#define PLUGIN_H

#include "gmc-common_global.h"

#include <QObject>

#include <QtPlugin>

#include <QList>

#include "treenode.h"

class QTranslator;

class Module;

class GMC_COMMON_SHARED_EXPORT Plugin : public QObject
{

    Q_OBJECT

public:

    Plugin( const QList< QPair< QString, QString > > & /*translations*/
          , QObject * /*parent*/ = 0 );
    virtual ~Plugin();

    qulonglong availableOperationsClass() const;

    const QString & name() const;
    const QString & description();
    const QList<TreeNode *> &modules();
    virtual bool isValid() const;

protected:

    QList< QPair< QString, QString > > _translations;
    qulonglong _availableOperationsClass;
    QString _name;
    QString _description;
    QList< TreeNode * > _modules;

};

#define PLUGIN_INTERFACE_iid "fly-admin-gmc/0.0"
Q_DECLARE_INTERFACE( Plugin, PLUGIN_INTERFACE_iid )

#endif // PLUGIN_H
