#ifndef PLUGINMODEL_H
#define PLUGINMODEL_H

#include "gmc-common_global.h"

#include <QAbstractItemModel>

class PluginContainer;

class GMC_COMMON_SHARED_EXPORT PluginModel : public QAbstractItemModel
{
    Q_OBJECT

public:

    enum PluginColumnsType { NameColumn
                           , DescriptionColumn
                           , _CountColumns };

    PluginModel( PluginContainer * /*pluginContainer*/ ,QObject * /*parent*/ = 0 );

    virtual QModelIndex index( int /*row*/
                             , int /*column*/
                             , const QModelIndex & /*parent*/ = QModelIndex() ) const;

    virtual QModelIndex parent( const QModelIndex & /*index*/ ) const;
    virtual int rowCount( const QModelIndex & /*index*/ = QModelIndex() ) const;
    virtual int columnCount( const QModelIndex & /*index*/ = QModelIndex() ) const;

    virtual QVariant data( const QModelIndex & /*index*/
                         , int /*role*/ = Qt::DisplayRole ) const;

    virtual QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const;

protected:

    QModelIndex ObjectToIndex( QObject * /*object*/ ) const;
    QObject * indexToObject(const QModelIndex & /*index*/ ) const;

protected slots:

    void pluginContainerAboutToBeReset();
    void pluginContainerReset();

protected:

    PluginContainer *_pluginContainer;

};

#endif // PLUGINMODEL_H
