#ifndef RECORDMODEL_H
#define RECORDMODEL_H

#include "gmc-common_global.h"

#include <QAbstractTableModel>
#include <QSortFilterProxyModel>

class Record;

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT RecordModel : public QAbstractTableModel
{

    Q_OBJECT

public:

    RecordModel( int ( * /*termsCount*/ )()
               , QVariant ( * /*termHeader*/ )( int )
               , Record * ( * /*createRecord*/ )()      //  ne isklucheno( createRecord == 0 )
               , QObject *parent = 0 );
    virtual ~RecordModel();

    bool isCreatable() const;

    void setRecordList( const QList< Record * > &/*recordsList*/ );
    void appendRecordList( const QList< Record * > &/*recordsList*/ );

    const QList< Record * > &getRecordList() const;
    QList< Record * > takeRecordList();
    void clear();

    virtual int columnCount(const QModelIndex & /*parentIndex*/ = QModelIndex() ) const;
    virtual int rowCount(const QModelIndex & /*parentIndex*/ = QModelIndex() ) const;

    virtual QVariant data( const QModelIndex & /*index*/, int /*role*/ = Qt::DisplayRole ) const;

    virtual QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ = Qt::DisplayRole ) const;
    virtual Qt::ItemFlags flags( const QModelIndex & /*index*/ ) const;

    virtual bool setData( const QModelIndex & /*index*/, const QVariant & /*value*/, int /*role*/ = Qt::EditRole );
    virtual bool insertRows( int /*row*/, int /*count*/, const QModelIndex & /*parentIndex*/ = QModelIndex() );
    virtual bool removeRows( int /*row*/, int /*count*/, const QModelIndex & /*parentIndex*/ = QModelIndex() );

    bool isEnabled() const;
    void setEnabled( bool /*enabled*/ );

    bool allRecordsValid() const;

public slots:

    void unchange();

protected:

    void clearRecordList();

protected:

    QList< Record * > _recordsList;

    int ( *_termsCount )();
    QVariant ( *_termHeader )( int );
    Record * ( *_createRecord )();      //  ne isklucheno( createRecord == 0 )

    bool _enabled;

};

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT RecordSortFilterProxyModel : public QSortFilterProxyModel
{

    Q_OBJECT

public:

    RecordSortFilterProxyModel( QObject * /*parent*/ = 0 );
    virtual ~RecordSortFilterProxyModel();

protected:

    virtual bool filterAcceptsRow( int /*srcRow*/, const QModelIndex & /*srcParentIndex*/ ) const;

};

//******************************************************************************

#endif // RECORDMODEL_H
